summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJory A. Pratt <anarchy@gentoo.org>2017-11-05 12:08:41 -0600
committerJory A. Pratt <anarchy@gentoo.org>2017-11-05 12:08:41 -0600
commit63da90c0023b2977b2e35518a6e3a18e9cd09785 (patch)
treecbfff405d45bea70116282ff951a42689c03703e
parentsys-kernel/hardened-sources - version bump 4.9.59 (diff)
downloadanarchy-63da90c0023b2977b2e35518a6e3a18e9cd09785.tar.gz
anarchy-63da90c0023b2977b2e35518a6e3a18e9cd09785.tar.bz2
anarchy-63da90c0023b2977b2e35518a6e3a18e9cd09785.zip
media-video/ffmpeg - add support for libressl for 3.3.5
-rw-r--r--media-video/ffmpeg/Manifest9
-rw-r--r--media-video/ffmpeg/ffmpeg-3.3.5.ebuild514
-rw-r--r--media-video/ffmpeg/files/chromium.patch36
-rw-r--r--media-video/ffmpeg/files/ffmpeg-3.2-libressl.patch57
-rw-r--r--media-video/ffmpeg/files/ffmpeg-3.3-libressl.patch57
-rw-r--r--media-video/ffmpeg/files/ffmpeg32-openjpeg22.patch106
-rw-r--r--media-video/ffmpeg/files/openjpeg22.patch106
-rw-r--r--media-video/ffmpeg/files/openjpeg23.patch109
-rw-r--r--media-video/ffmpeg/metadata.xml65
9 files changed, 1059 insertions, 0 deletions
diff --git a/media-video/ffmpeg/Manifest b/media-video/ffmpeg/Manifest
new file mode 100644
index 0000000..f4a2f94
--- /dev/null
+++ b/media-video/ffmpeg/Manifest
@@ -0,0 +1,9 @@
+AUX chromium.patch 1420 SHA256 934ccd37bf4e36b20bf4fc1e6599f6e6489c3bac7940ca48bc93ff93dd20696f SHA512 1f3f6d08aac64bb8c9d8a974170064b8a3531a6d06cea6fb208439dc687addeaf0c90f7f407dd7e71f50cd524f69c110c92d5276d04fe3bcaf7fb1ff2494ec59 WHIRLPOOL 46889e7842bd134e94f2a79ccddb561e0f7128557973e2ffe0b6a5d85a789a80eecaa64cdcea0cd7fd61a01fe8459b30c62d960a5d449ea1b4dfa938e2cbdff5
+AUX ffmpeg-3.2-libressl.patch 2030 SHA256 7af99ba40d7ae9742203842f5e340c3a0d2b33f41c77cd8bba90e826e71922da SHA512 61c31751f4bf6b8c88b2c985f42e33b3d1738575e41dbc31a5192649d16af0112c555583e37865d809399c6d40f60c85c1ea23b59677c747aeca7c2cfa38254b WHIRLPOOL dcd1890fbaf57d119c18a80f012a768aafe9b51890611be85edbae5d59af18a740b9bf29d7988e3974ed68ac4930e6daff4fc2b12c049a50856ccd36f213af56
+AUX ffmpeg-3.3-libressl.patch 2028 SHA256 590b44de9161d1bbcc1062c91ed41a924ddde835c47445a6d4aa3d28cf4f8cdf SHA512 9a259be0b1957b715d07ca27ef72d36a9f297be06e4d875ed711d7b3ebcad345e6e11e1e447daf07e5b5f5f2bcf2f08e14689f36d427ddbf1b6ace1583838e92 WHIRLPOOL 4c34582eb3ed42b6020f276786545ad911283d6dcda47b3d69f4718691a1c7f1cbe89a701549622b1f79a02a338174f1e0b8beac9f8ee21bb2c6db7bce218a9a
+AUX ffmpeg32-openjpeg22.patch 4777 SHA256 4a9ed7ff8716fd6e3f311c09af3a062023fe922dcc4b6786922e0e2947f77547 SHA512 0d619b0e353ee9f80dffdb94bedd31b55fb4e6a18a0e60d8ef7119e5012583c1c0531b0b200b41c32caaa71cbade4899f74c9d0ae70d15403ef0aa6f3d77e07d WHIRLPOOL 3d49d34ff0bd5ac8638b91c16e7e1280d60c2565dd4e9593406c240ecc98f14bea1c7f9b54f26fb6f7c65d531cfe793f854f7772addda903abd71f6692aadbd8
+AUX openjpeg22.patch 4770 SHA256 48d399b12299da0eb709412e52b6e545afe82ba4bb3e59f4a02828985f9dfed5 SHA512 8a198910cdf43df83fdf50e372c2ec5d911637dd61768d5ac3a1984f99d1f374f594af9ff6c501b248c390a22898e4964f7d07c81eb3586fa1bebad2c9e00730 WHIRLPOOL c655b65761b198225f03a072ec690c81eb27a2972f602a3ef0be260e0e4acb242357f7421a213e32af0159da4a3398c5b5794a0bb616e7e4a36e6698341e9208
+AUX openjpeg23.patch 5105 SHA256 c3d4844cee8704f2205694df7be44dcc77ea5fb35e092cd15182f8b0b533cbcb SHA512 a1e3b91add49a80633e19eb49870ecb7ef1493cf3503d121bdeb74f2fcd0320b8e5f04a3505241f7375f4a598f5da651afb92350e3b92412977f55b9193409a7 WHIRLPOOL d2e9bf24aae50ebc27a47aefebab7e81511a0e46fac1344119bd4e9f955af552d6e05450b1675bb799955fc67317d459832fa8d3e48dcc510f5190d6ce9d183f
+DIST ffmpeg-3.3.5.tar.bz2 9945243 SHA256 1b434cff8a327e54fd0f611420996e3419c58b795d51a5b588ace2a674f1060a SHA512 b97eb61f1c8f8ee95d79c6c28b37a0a99ad7752605714bfe8827366d319aed8bcaf2403cefb856604e8d61bca54573838c2ea0d38fa89ab453ccdd46b104725a WHIRLPOOL d58c5df3fc3df25173a1a719f663d2821bbf283e346ddc289640cacd804e5cbc8359539f4b5931677aacb2c9e8a31d036b79492b00dbe2717c0c5563f2a2857a
+EBUILD ffmpeg-3.3.5.ebuild 16235 SHA256 0862f9114eb61e22a864056616d3ae86806436493ce56c5084bc3ff6bac3e2e7 SHA512 8038b6fe0748db1ee30c92221ecca30d6c5a1fc7daaf5dfac7845cfc72aeab7d1b8b2e6649a38f24c20f289bea91e62f5bafb8c96eb3a9ce317fff08d6b8ead6 WHIRLPOOL a919667670a655e87670f6964467d37b093668eae34af0e0a2d7dd1a05eba8914a360fc785408fae354a2bd98d1c15de2e4c273b1a5aac00238cb9d9764b1ce3
+MISC metadata.xml 5585 SHA256 a6fc43267404a7d11df8ff36981ec63db2f6e8f0a2fa7d10575d2499e42835aa SHA512 7ed5ff26cc2cabff62045f00354cd5b7f5638d5d766ccf3d2b6eedff2b059b56bffc033e57c0d61deee5566d0c274403faa671ccefa58dc79fbeb515fa4dd5e0 WHIRLPOOL 6cff514cd37c978972f55072e8dec790e167a88e1aa4882301944e244182da698835792e1c3a11bccdfa3bd7ff3d015a8dd20b3c599a160f0e23e7b84e67c9d4
diff --git a/media-video/ffmpeg/ffmpeg-3.3.5.ebuild b/media-video/ffmpeg/ffmpeg-3.3.5.ebuild
new file mode 100644
index 0000000..de50fc5
--- /dev/null
+++ b/media-video/ffmpeg/ffmpeg-3.3.5.ebuild
@@ -0,0 +1,514 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+# Subslot: libavutil major.libavcodec major.libavformat major
+# Since FFmpeg ships several libraries, subslot is kind of limited here.
+# Most consumers will use those three libraries, if a "less used" library
+# changes its soname, consumers will have to be rebuilt the old way
+# (preserve-libs).
+# If, for example, a package does not link to libavformat and only libavformat
+# changes its ABI then this package will be rebuilt needlessly. Hence, such a
+# package is free _not_ to := depend on FFmpeg but I would strongly encourage
+# doing so since such a case is unlikely.
+FFMPEG_SUBSLOT=55.57.57
+
+SCM=""
+if [ "${PV#9999}" != "${PV}" ] ; then
+ SCM="git-r3"
+ EGIT_REPO_URI="git://source.ffmpeg.org/ffmpeg.git"
+fi
+
+inherit eutils flag-o-matic multilib multilib-minimal toolchain-funcs ${SCM}
+
+DESCRIPTION="Complete solution to record, convert and stream audio and video. Includes libavcodec"
+HOMEPAGE="http://ffmpeg.org/"
+if [ "${PV#9999}" != "${PV}" ] ; then
+ SRC_URI=""
+elif [ "${PV%_p*}" != "${PV}" ] ; then # Snapshot
+ SRC_URI="mirror://gentoo/${P}.tar.bz2"
+else # Release
+ SRC_URI="http://ffmpeg.org/releases/${P/_/-}.tar.bz2"
+fi
+FFMPEG_REVISION="${PV#*_p}"
+
+SLOT="0/${FFMPEG_SUBSLOT}"
+LICENSE="
+ !gpl? ( LGPL-2.1 )
+ gpl? ( GPL-2 )
+ amr? (
+ gpl? ( GPL-3 )
+ !gpl? ( LGPL-3 )
+ )
+ gmp? (
+ gpl? ( GPL-3 )
+ !gpl? ( LGPL-3 )
+ )
+ encode? (
+ amrenc? (
+ gpl? ( GPL-3 )
+ !gpl? ( LGPL-3 )
+ )
+ )
+ samba? ( GPL-3 )
+"
+if [ "${PV#9999}" = "${PV}" ] ; then
+ KEYWORDS="~amd64 ~arm ~arm64 ~hppa ~ia64 ~mips ~ppc ~ppc64 ~x86 ~amd64-fbsd ~x86-fbsd ~amd64-linux ~arm-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~x64-solaris ~x86-solaris"
+fi
+
+# Options to use as use_enable in the foo[:bar] form.
+# This will feed configure with $(use_enable foo bar)
+# or $(use_enable foo foo) if no :bar is set.
+# foo is added to IUSE.
+FFMPEG_FLAG_MAP=(
+ +bzip2:bzlib cpudetection:runtime-cpudetect debug gcrypt gnutls gmp
+ +gpl +hardcoded-tables +iconv lzma +network openssl +postproc
+ samba:libsmbclient sdl:ffplay sdl:sdl2 vaapi vdpau X:xlib xcb:libxcb
+ xcb:libxcb-shm xcb:libxcb-xfixes +zlib
+ # libavdevice options
+ cdio:libcdio iec61883:libiec61883 ieee1394:libdc1394 libcaca openal
+ opengl
+ # indevs
+ libv4l:libv4l2 pulseaudio:libpulse
+ # decoders
+ amr:libopencore-amrwb amr:libopencore-amrnb fdk:libfdk-aac
+ jpeg2k:libopenjpeg bluray:libbluray celt:libcelt gme:libgme gsm:libgsm
+ mmal modplug:libmodplug opus:libopus libilbc librtmp ssh:libssh
+ schroedinger:libschroedinger speex:libspeex vorbis:libvorbis vpx:libvpx
+ zvbi:libzvbi
+ # libavfilter options
+ bs2b:libbs2b chromaprint flite:libflite frei0r
+ fribidi:libfribidi fontconfig ladspa libass truetype:libfreetype
+ rubberband:librubberband sofalizer:netcdf zeromq:libzmq zimg:libzimg
+ # libswresample options
+ libsoxr
+ # Threads; we only support pthread for now but ffmpeg supports more
+ +threads:pthreads
+)
+
+# Same as above but for encoders, i.e. they do something only with USE=encode.
+FFMPEG_ENCODER_FLAG_MAP=(
+ amrenc:libvo-amrwbenc mp3:libmp3lame
+ kvazaar:libkvazaar nvenc:nvenc
+ openh264:libopenh264 snappy:libsnappy theora:libtheora twolame:libtwolame
+ wavpack:libwavpack webp:libwebp x264:libx264 x265:libx265 xvid:libxvid
+)
+
+IUSE="
+ alsa chromium doc +encode jack libressl oss pic static-libs test v4l
+ ${FFMPEG_FLAG_MAP[@]%:*}
+ ${FFMPEG_ENCODER_FLAG_MAP[@]%:*}
+"
+
+# Strings for CPU features in the useflag[:configure_option] form
+# if :configure_option isn't set, it will use 'useflag' as configure option
+ARM_CPU_FEATURES=(
+ cpu_flags_arm_thumb:armv5te
+ cpu_flags_arm_v6:armv6
+ cpu_flags_arm_thumb2:armv6t2
+ cpu_flags_arm_neon:neon
+ cpu_flags_arm_vfp:vfp
+ cpu_flags_arm_vfpv3:vfpv3
+ cpu_flags_arm_v8:armv8
+)
+ARM_CPU_REQUIRED_USE="
+ arm64? ( cpu_flags_arm_v8 )
+ cpu_flags_arm_v8? ( cpu_flags_arm_vfpv3 cpu_flags_arm_neon )
+ cpu_flags_arm_neon? ( cpu_flags_arm_thumb2 cpu_flags_arm_vfp )
+ cpu_flags_arm_vfpv3? ( cpu_flags_arm_vfp )
+ cpu_flags_arm_thumb2? ( cpu_flags_arm_v6 )
+ cpu_flags_arm_v6? ( cpu_flags_arm_thumb )
+"
+MIPS_CPU_FEATURES=( mipsdspr1:mipsdsp mipsdspr2 mipsfpu )
+PPC_CPU_FEATURES=( altivec )
+X86_CPU_FEATURES_RAW=( 3dnow:amd3dnow 3dnowext:amd3dnowext aes:aesni avx:avx avx2:avx2 fma3:fma3 fma4:fma4 mmx:mmx mmxext:mmxext sse:sse sse2:sse2 sse3:sse3 ssse3:ssse3 sse4_1:sse4 sse4_2:sse42 xop:xop )
+X86_CPU_FEATURES=( ${X86_CPU_FEATURES_RAW[@]/#/cpu_flags_x86_} )
+X86_CPU_REQUIRED_USE="
+ cpu_flags_x86_avx2? ( cpu_flags_x86_avx )
+ cpu_flags_x86_fma4? ( cpu_flags_x86_avx )
+ cpu_flags_x86_fma3? ( cpu_flags_x86_avx )
+ cpu_flags_x86_xop? ( cpu_flags_x86_avx )
+ cpu_flags_x86_avx? ( cpu_flags_x86_sse4_2 )
+ cpu_flags_x86_aes? ( cpu_flags_x86_sse4_2 )
+ cpu_flags_x86_sse4_2? ( cpu_flags_x86_sse4_1 )
+ cpu_flags_x86_sse4_1? ( cpu_flags_x86_ssse3 )
+ cpu_flags_x86_ssse3? ( cpu_flags_x86_sse3 )
+ cpu_flags_x86_sse3? ( cpu_flags_x86_sse2 )
+ cpu_flags_x86_sse2? ( cpu_flags_x86_sse )
+ cpu_flags_x86_sse? ( cpu_flags_x86_mmxext )
+ cpu_flags_x86_mmxext? ( cpu_flags_x86_mmx )
+ cpu_flags_x86_3dnowext? ( cpu_flags_x86_3dnow )
+ cpu_flags_x86_3dnow? ( cpu_flags_x86_mmx )
+"
+
+IUSE="${IUSE}
+ ${ARM_CPU_FEATURES[@]%:*}
+ ${MIPS_CPU_FEATURES[@]%:*}
+ ${PPC_CPU_FEATURES[@]%:*}
+ ${X86_CPU_FEATURES[@]%:*}
+"
+
+CPU_REQUIRED_USE="
+ ${ARM_CPU_REQUIRED_USE}
+ ${X86_CPU_REQUIRED_USE}
+"
+
+# "$(tc-arch):XXX" form where XXX_CPU_FEATURES are the cpu features that apply to
+# $(tc-arch).
+CPU_FEATURES_MAP="
+ arm:ARM
+ arm64:ARM
+ mips:MIPS
+ ppc:PPC
+ ppc64:PPC
+ x86:X86
+ amd64:X86
+"
+
+FFTOOLS=( aviocat cws2fws ffescape ffeval ffhash fourcc2pixfmt graph2dot ismindex pktdumper qt-faststart sidxindex trasher )
+IUSE="${IUSE} ${FFTOOLS[@]/#/+fftools_}"
+
+RDEPEND="
+ alsa? ( >=media-libs/alsa-lib-1.0.27.2[${MULTILIB_USEDEP}] )
+ amr? ( >=media-libs/opencore-amr-0.1.3-r1[${MULTILIB_USEDEP}] )
+ bluray? ( >=media-libs/libbluray-0.3.0-r1:=[${MULTILIB_USEDEP}] )
+ bs2b? ( >=media-libs/libbs2b-3.1.0-r1[${MULTILIB_USEDEP}] )
+ bzip2? ( >=app-arch/bzip2-1.0.6-r4[${MULTILIB_USEDEP}] )
+ cdio? ( >=dev-libs/libcdio-paranoia-0.90_p1-r1[${MULTILIB_USEDEP}] )
+ celt? ( >=media-libs/celt-0.11.1-r1[${MULTILIB_USEDEP}] )
+ chromaprint? ( >=media-libs/chromaprint-1.2-r1[${MULTILIB_USEDEP}] )
+ encode? (
+ amrenc? ( >=media-libs/vo-amrwbenc-0.1.2-r1[${MULTILIB_USEDEP}] )
+ kvazaar? ( media-libs/kvazaar[${MULTILIB_USEDEP}] )
+ mp3? ( >=media-sound/lame-3.99.5-r1[${MULTILIB_USEDEP}] )
+ nvenc? ( media-video/nvidia_video_sdk )
+ openh264? ( >=media-libs/openh264-1.4.0-r1[${MULTILIB_USEDEP}] )
+ snappy? ( >=app-arch/snappy-1.1.2-r1:=[${MULTILIB_USEDEP}] )
+ theora? (
+ >=media-libs/libtheora-1.1.1[encode,${MULTILIB_USEDEP}]
+ >=media-libs/libogg-1.3.0[${MULTILIB_USEDEP}]
+ )
+ twolame? ( >=media-sound/twolame-0.3.13-r1[${MULTILIB_USEDEP}] )
+ wavpack? ( >=media-sound/wavpack-4.60.1-r1[${MULTILIB_USEDEP}] )
+ webp? ( >=media-libs/libwebp-0.3.0:=[${MULTILIB_USEDEP}] )
+ x264? ( >=media-libs/x264-0.0.20130506:=[${MULTILIB_USEDEP}] )
+ x265? ( >=media-libs/x265-1.6:=[${MULTILIB_USEDEP}] )
+ xvid? ( >=media-libs/xvid-1.3.2-r1[${MULTILIB_USEDEP}] )
+ )
+ fdk? ( >=media-libs/fdk-aac-0.1.3:=[${MULTILIB_USEDEP}] )
+ flite? ( >=app-accessibility/flite-1.4-r4[${MULTILIB_USEDEP}] )
+ fontconfig? ( >=media-libs/fontconfig-2.10.92[${MULTILIB_USEDEP}] )
+ frei0r? ( media-plugins/frei0r-plugins )
+ fribidi? ( >=dev-libs/fribidi-0.19.6[${MULTILIB_USEDEP}] )
+ gcrypt? ( >=dev-libs/libgcrypt-1.6:0=[${MULTILIB_USEDEP}] )
+ gme? ( >=media-libs/game-music-emu-0.6.0[${MULTILIB_USEDEP}] )
+ gmp? ( >=dev-libs/gmp-6:0=[${MULTILIB_USEDEP}] )
+ gnutls? ( >=net-libs/gnutls-2.12.23-r6:=[${MULTILIB_USEDEP}] )
+ gsm? ( >=media-sound/gsm-1.0.13-r1[${MULTILIB_USEDEP}] )
+ iconv? ( >=virtual/libiconv-0-r1[${MULTILIB_USEDEP}] )
+ iec61883? (
+ >=media-libs/libiec61883-1.2.0-r1[${MULTILIB_USEDEP}]
+ >=sys-libs/libraw1394-2.1.0-r1[${MULTILIB_USEDEP}]
+ >=sys-libs/libavc1394-0.5.4-r1[${MULTILIB_USEDEP}]
+ )
+ ieee1394? (
+ >=media-libs/libdc1394-2.2.1[${MULTILIB_USEDEP}]
+ >=sys-libs/libraw1394-2.1.0-r1[${MULTILIB_USEDEP}]
+ )
+ jack? ( virtual/jack[${MULTILIB_USEDEP}] )
+ jpeg2k? ( >=media-libs/openjpeg-2:2[${MULTILIB_USEDEP}] )
+ libass? ( >=media-libs/libass-0.10.2:=[${MULTILIB_USEDEP}] )
+ libcaca? ( >=media-libs/libcaca-0.99_beta18-r1[${MULTILIB_USEDEP}] )
+ libilbc? ( >=media-libs/libilbc-2[${MULTILIB_USEDEP}] )
+ libsoxr? ( >=media-libs/soxr-0.1.0[${MULTILIB_USEDEP}] )
+ libv4l? ( >=media-libs/libv4l-0.9.5[${MULTILIB_USEDEP}] )
+ lzma? ( >=app-arch/xz-utils-5.0.5-r1[${MULTILIB_USEDEP}] )
+ mmal? ( media-libs/raspberrypi-userland )
+ modplug? ( >=media-libs/libmodplug-0.8.8.4-r1[${MULTILIB_USEDEP}] )
+ openal? ( >=media-libs/openal-1.15.1[${MULTILIB_USEDEP}] )
+ opengl? ( >=virtual/opengl-7.0-r1[${MULTILIB_USEDEP}] )
+ openssl? (
+ !libressl? ( >=dev-libs/openssl-1.0.1h-r2:0[${MULTILIB_USEDEP}] )
+ libressl? ( dev-libs/libressl[${MULTILIB_USEDEP}] )
+ )
+ opus? ( >=media-libs/opus-1.0.2-r2[${MULTILIB_USEDEP}] )
+ pulseaudio? ( >=media-sound/pulseaudio-2.1-r1[${MULTILIB_USEDEP}] )
+ librtmp? ( >=media-video/rtmpdump-2.4_p20131018[${MULTILIB_USEDEP}] )
+ rubberband? ( >=media-libs/rubberband-1.8.1-r1[${MULTILIB_USEDEP}] )
+ samba? ( >=net-fs/samba-3.6.23-r1[${MULTILIB_USEDEP}] )
+ schroedinger? ( >=media-libs/schroedinger-1.0.11-r1[${MULTILIB_USEDEP}] )
+ sdl? ( media-libs/libsdl2[sound,video,${MULTILIB_USEDEP}] )
+ sofalizer? (
+ >=sci-libs/netcdf-4.3.2-r1[hdf5]
+ >=sci-libs/hdf5-1.8.18[hl]
+ )
+ speex? ( >=media-libs/speex-1.2_rc1-r1[${MULTILIB_USEDEP}] )
+ ssh? ( >=net-libs/libssh-0.5.5[${MULTILIB_USEDEP}] )
+ truetype? ( >=media-libs/freetype-2.5.0.1:2[${MULTILIB_USEDEP}] )
+ vaapi? ( >=x11-libs/libva-1.2.1-r1[${MULTILIB_USEDEP}] )
+ vdpau? ( >=x11-libs/libvdpau-0.7[${MULTILIB_USEDEP}] )
+ vorbis? (
+ >=media-libs/libvorbis-1.3.3-r1[${MULTILIB_USEDEP}]
+ >=media-libs/libogg-1.3.0[${MULTILIB_USEDEP}]
+ )
+ vpx? ( >=media-libs/libvpx-1.4.0:=[${MULTILIB_USEDEP}] )
+ X? (
+ >=x11-libs/libX11-1.6.2[${MULTILIB_USEDEP}]
+ >=x11-libs/libXext-1.3.2[${MULTILIB_USEDEP}]
+ >=x11-libs/libXv-1.0.10[${MULTILIB_USEDEP}]
+ )
+ xcb? ( >=x11-libs/libxcb-1.4[${MULTILIB_USEDEP}] )
+ zeromq? ( >=net-libs/zeromq-4.1.6 )
+ zimg? ( >=media-libs/zimg-2.4:=[${MULTILIB_USEDEP}] )
+ zlib? ( >=sys-libs/zlib-1.2.8-r1[${MULTILIB_USEDEP}] )
+ zvbi? ( >=media-libs/zvbi-0.2.35[${MULTILIB_USEDEP}] )
+ !media-video/qt-faststart
+ postproc? ( !media-libs/libpostproc )
+"
+
+DEPEND="${RDEPEND}
+ >=sys-devel/make-3.81
+ doc? ( sys-apps/texinfo )
+ >=virtual/pkgconfig-0-r1[${MULTILIB_USEDEP}]
+ ladspa? ( >=media-libs/ladspa-sdk-1.13-r2[${MULTILIB_USEDEP}] )
+ cpu_flags_x86_mmx? ( >=dev-lang/yasm-1.2 )
+ test? ( net-misc/wget sys-devel/bc )
+ v4l? ( sys-kernel/linux-headers )
+"
+
+RDEPEND="${RDEPEND}
+ abi_x86_32? ( !<=app-emulation/emul-linux-x86-medialibs-20140508-r3
+ !app-emulation/emul-linux-x86-medialibs[-abi_x86_32(-)] )"
+
+# Code requiring FFmpeg to be built under gpl license
+GPL_REQUIRED_USE="
+ postproc? ( gpl )
+ frei0r? ( gpl )
+ cdio? ( gpl )
+ samba? ( gpl )
+ encode? (
+ x264? ( gpl )
+ x265? ( gpl )
+ xvid? ( gpl )
+ X? ( !xcb? ( gpl ) )
+ )
+"
+REQUIRED_USE="
+ libv4l? ( v4l )
+ fftools_cws2fws? ( zlib )
+ test? ( encode )
+ ${GPL_REQUIRED_USE}
+ ${CPU_REQUIRED_USE}"
+RESTRICT="
+ gpl? ( openssl? ( bindist ) fdk? ( bindist ) )
+"
+
+S=${WORKDIR}/${P/_/-}
+
+MULTILIB_WRAPPED_HEADERS=(
+ /usr/include/libavutil/avconfig.h
+)
+
+PATCHES=(
+ "${FILESDIR}"/openjpeg22.patch
+ "${FILESDIR}"/openjpeg23.patch
+ "${FILESDIR}"/chromium.patch
+ "${FILESDIR}"/${PN}-3.3-libressl.patch
+)
+
+src_prepare() {
+ if [[ "${PV%_p*}" != "${PV}" ]] ; then # Snapshot
+ export revision=git-N-${FFMPEG_REVISION}
+ fi
+ default
+ echo 'include $(SRC_PATH)/ffbuild/libffmpeg.mak' >> Makefile || die
+}
+
+multilib_src_configure() {
+ local myconf=( ${EXTRA_FFMPEG_CONF} )
+
+ local ffuse=( "${FFMPEG_FLAG_MAP[@]}" )
+ use openssl && use gpl && myconf+=( --enable-nonfree )
+ use samba && myconf+=( --enable-version3 )
+
+ # Encoders
+ if use encode ; then
+ ffuse+=( "${FFMPEG_ENCODER_FLAG_MAP[@]}" )
+
+ # Licensing.
+ if use amrenc ; then
+ myconf+=( --enable-version3 )
+ fi
+ else
+ myconf+=( --disable-encoders )
+ fi
+
+ # Indevs
+ use v4l || myconf+=( --disable-indev=v4l2 --disable-outdev=v4l2 )
+ for i in alsa oss jack ; do
+ use ${i} || myconf+=( --disable-indev=${i} )
+ done
+
+ # Outdevs
+ for i in alsa oss sdl ; do
+ use ${i} || myconf+=( --disable-outdev=${i} )
+ done
+
+ # Decoders
+ use amr && myconf+=( --enable-version3 )
+ use gmp && myconf+=( --enable-version3 )
+ use fdk && use gpl && myconf+=( --enable-nonfree )
+
+ for i in "${ffuse[@]#+}" ; do
+ myconf+=( $(use_enable ${i%:*} ${i#*:}) )
+ done
+
+ # (temporarily) disable non-multilib deps
+ if ! multilib_is_native_abi; then
+ for i in frei0r netcdf libzmq ; do
+ myconf+=( --disable-${i} )
+ done
+ fi
+
+ # CPU features
+ for i in ${CPU_FEATURES_MAP} ; do
+ if [ "$(tc-arch)" = "${i%:*}" ] ; then
+ local var="${i#*:}_CPU_FEATURES[@]"
+ for j in ${!var} ; do
+ use ${j%:*} || myconf+=( --disable-${j#*:} )
+ done
+ fi
+ done
+
+ if use pic ; then
+ myconf+=( --enable-pic )
+ # disable asm code if PIC is required
+ # as the provided asm decidedly is not PIC for x86.
+ [[ ${ABI} == x86 ]] && myconf+=( --disable-asm )
+ fi
+ [[ ${ABI} == x32 ]] && myconf+=( --disable-asm ) #427004
+
+ # Try to get cpu type based on CFLAGS.
+ # Bug #172723
+ # We need to do this so that features of that CPU will be better used
+ # If they contain an unknown CPU it will not hurt since ffmpeg's configure
+ # will just ignore it.
+ for i in $(get-flag mcpu) $(get-flag march) ; do
+ [[ ${i} = native ]] && i="host" # bug #273421
+ myconf+=( --cpu=${i} )
+ break
+ done
+
+ # LTO support, bug #566282
+ is-flagq "-flto*" && myconf+=( "--enable-lto" )
+
+ # Mandatory configuration
+ myconf=(
+ --enable-avfilter
+ --enable-avresample
+ --disable-stripping
+ "${myconf[@]}"
+ )
+
+ # cross compile support
+ if tc-is-cross-compiler ; then
+ myconf+=( --enable-cross-compile --arch=$(tc-arch-kernel) --cross-prefix=${CHOST}- --host-cc="$(tc-getBUILD_CC)" )
+ case ${CHOST} in
+ *freebsd*)
+ myconf+=( --target-os=freebsd )
+ ;;
+ *mingw32*)
+ myconf+=( --target-os=mingw32 )
+ ;;
+ *linux*)
+ myconf+=( --target-os=linux )
+ ;;
+ esac
+ fi
+
+ # doc
+ myconf+=(
+ $(multilib_native_use_enable doc)
+ $(multilib_native_use_enable doc htmlpages)
+ $(multilib_native_enable manpages)
+ )
+
+ set -- "${S}/configure" \
+ --prefix="${EPREFIX}/usr" \
+ --libdir="${EPREFIX}/usr/$(get_libdir)" \
+ --shlibdir="${EPREFIX}/usr/$(get_libdir)" \
+ --docdir="${EPREFIX}/usr/share/doc/${PF}/html" \
+ --mandir="${EPREFIX}/usr/share/man" \
+ --enable-shared \
+ --cc="$(tc-getCC)" \
+ --cxx="$(tc-getCXX)" \
+ --ar="$(tc-getAR)" \
+ --optflags="${CFLAGS}" \
+ $(use_enable static-libs static) \
+ "${myconf[@]}"
+ echo "${@}"
+ "${@}" || die
+
+ if multilib_is_native_abi && use chromium; then
+ einfo "Configuring for Chromium"
+ mkdir -p ../chromium || die
+ pushd ../chromium >/dev/null || die
+ set -- "${@}" \
+ --disable-shared \
+ --enable-static \
+ --enable-pic \
+ --extra-cflags="-DFF_API_CONVERGENCE_DURATION=0"
+ echo "${@}"
+ "${@}" || die
+ popd >/dev/null || die
+ fi
+}
+
+multilib_src_compile() {
+ emake V=1
+
+ if multilib_is_native_abi; then
+ for i in "${FFTOOLS[@]}" ; do
+ if use fftools_${i} ; then
+ emake V=1 tools/${i}$(get_exeext)
+ fi
+ done
+
+ if use chromium; then
+ einfo "Compiling for Chromium"
+ pushd ../chromium >/dev/null || die
+ emake V=1 libffmpeg
+ popd >/dev/null || die
+ fi
+ fi
+}
+
+multilib_src_install() {
+ emake V=1 DESTDIR="${D}" install install-doc
+
+ if multilib_is_native_abi; then
+ for i in "${FFTOOLS[@]}" ; do
+ if use fftools_${i} ; then
+ dobin tools/${i}$(get_exeext)
+ fi
+ done
+
+ if use chromium; then
+ einfo "Installing for Chromium"
+ pushd ../chromium >/dev/null || die
+ emake V=1 DESTDIR="${D}" install-libffmpeg
+ popd >/dev/null || die
+ fi
+ fi
+}
+
+multilib_src_install_all() {
+ dodoc Changelog README.md CREDITS doc/*.txt doc/APIchanges
+ [ -f "RELEASE_NOTES" ] && dodoc "RELEASE_NOTES"
+}
+
+multilib_src_test() {
+ LD_LIBRARY_PATH="${BUILD_DIR}/libpostproc:${BUILD_DIR}/libswscale:${BUILD_DIR}/libswresample:${BUILD_DIR}/libavcodec:${BUILD_DIR}/libavdevice:${BUILD_DIR}/libavfilter:${BUILD_DIR}/libavformat:${BUILD_DIR}/libavutil:${BUILD_DIR}/libavresample" \
+ emake V=1 fate
+}
diff --git a/media-video/ffmpeg/files/chromium.patch b/media-video/ffmpeg/files/chromium.patch
new file mode 100644
index 0000000..60a3e5d
--- /dev/null
+++ b/media-video/ffmpeg/files/chromium.patch
@@ -0,0 +1,36 @@
+Allow libffmpeg to be built for Chromium-based browsers
+https://patchwork.ffmpeg.org/patch/4500/
+
+NOTE: This patch lacks the Makefile include line. We append it
+manually instead to make patching across different versions easier.
+
+diff --git a/ffbuild/libffmpeg.mak b/ffbuild/libffmpeg.mak
+new file mode 100644
+index 0000000..992cf3c
+--- /dev/null
++++ b/ffbuild/libffmpeg.mak
+@@ -0,0 +1,21 @@
++LIBFFMPEG = $(SLIBPREF)ffmpeg$(SLIBSUF)
++LIBFFMPEG_LINK = $(LD) -shared -Wl,-soname,$(LIBFFMPEG) -Wl,-Bsymbolic -Wl,-z,now -Wl,-z,relro -Wl,-z,defs -Wl,--gc-sections $(LDFLAGS) $(LDLIBFLAGS) -o $(LIBFFMPEG)
++
++libffmpeg-: libavcodec/$(LIBPREF)avcodec$(LIBSUF) libavformat/$(LIBPREF)avformat$(LIBSUF) libavutil/$(LIBPREF)avutil$(LIBSUF) libswresample/$(LIBPREF)swresample$(LIBSUF)
++ $(LIBFFMPEG_LINK) -Wl,--whole-archive $^ -Wl,--no-whole-archive $(FFEXTRALIBS)
++
++libffmpeg-yes: libavcodec/$(SLIBPREF)avcodec$(SLIBSUF) libavformat/$(SLIBPREF)avformat$(SLIBSUF) libavutil/$(SLIBPREF)avutil$(SLIBSUF)
++ $(LIBFFMPEG_LINK) -Wl,--no-as-needed -lavcodec -lavformat -lavutil
++
++$(LIBFFMPEG): libffmpeg-$(CONFIG_SHARED)
++libffmpeg: $(LIBFFMPEG)
++
++install-libffmpeg: $(LIBFFMPEG)
++ $(Q)mkdir -p "$(SHLIBDIR)/chromium"
++ $(INSTALL) -m 755 $< "$(SHLIBDIR)/chromium/$<"
++ $(STRIP) "$(SHLIBDIR)/chromium/$<"
++
++uninstall-libffmpeg:
++ $(RM) "$(SHLIBDIR)/chromium/$(LIBFFMPEG)"
++
++.PHONY: libffmpeg libffmpeg-* install-libffmpeg
+--
+2.13.1
+
diff --git a/media-video/ffmpeg/files/ffmpeg-3.2-libressl.patch b/media-video/ffmpeg/files/ffmpeg-3.2-libressl.patch
new file mode 100644
index 0000000..267785a
--- /dev/null
+++ b/media-video/ffmpeg/files/ffmpeg-3.2-libressl.patch
@@ -0,0 +1,57 @@
+diff -Naur ffmpeg-3.2.orig/libavformat/tls_openssl.c ffmpeg-3.2/libavformat/tls_openssl.c
+--- ffmpeg-3.2.orig/libavformat/tls_openssl.c 2016-10-28 10:20:46.872620829 -0700
++++ ffmpeg-3.2/libavformat/tls_openssl.c 2016-10-28 10:22:46.153045913 -0700
+@@ -43,7 +43,7 @@
+ TLSShared tls_shared;
+ SSL_CTX *ctx;
+ SSL *ssl;
+-#if OPENSSL_VERSION_NUMBER >= 0x1010000fL
++#if OPENSSL_VERSION_NUMBER >= 0x1010000fL && !defined(LIBRESSL_VERSION_NUMBER)
+ BIO_METHOD* url_bio_method;
+ #endif
+ } TLSContext;
+@@ -68,7 +68,7 @@
+
+ static int url_bio_create(BIO *b)
+ {
+-#if OPENSSL_VERSION_NUMBER >= 0x1010000fL
++#if OPENSSL_VERSION_NUMBER >= 0x1010000fL && !defined(LIBRESSL_VERSION_NUMBER)
+ BIO_set_init(b, 1);
+ BIO_set_data(b, NULL);
+ BIO_set_flags(b, 0);
+@@ -85,7 +85,7 @@
+ return 1;
+ }
+
+-#if OPENSSL_VERSION_NUMBER >= 0x1010000fL
++#if OPENSSL_VERSION_NUMBER >= 0x1010000fL && !defined(LIBRESSL_VERSION_NUMBER)
+ #define GET_BIO_DATA(x) BIO_get_data(x);
+ #else
+ #define GET_BIO_DATA(x) (x)->ptr;
+@@ -133,7 +133,7 @@
+ return url_bio_bwrite(b, str, strlen(str));
+ }
+
+-#if OPENSSL_VERSION_NUMBER < 0x1010000fL
++#if OPENSSL_VERSION_NUMBER < 0x1010000fL || defined(LIBRESSL_VERSION_NUMBER)
+ static BIO_METHOD url_bio_method = {
+ .type = BIO_TYPE_SOURCE_SINK,
+ .name = "urlprotocol bio",
+@@ -212,7 +212,7 @@
+ SSL_CTX_free(c->ctx);
+ if (c->tls_shared.tcp)
+ ffurl_close(c->tls_shared.tcp);
+-#if OPENSSL_VERSION_NUMBER >= 0x1010000fL
++#if OPENSSL_VERSION_NUMBER >= 0x1010000fL && !defined(LIBRESSL_VERSION_NUMBER)
+ if (c->url_bio_method)
+ BIO_meth_free(c->url_bio_method);
+ #endif
+@@ -265,7 +265,7 @@
+ ret = AVERROR(EIO);
+ goto fail;
+ }
+-#if OPENSSL_VERSION_NUMBER >= 0x1010000fL
++#if OPENSSL_VERSION_NUMBER >= 0x1010000fL && !defined(LIBRESSL_VERSION_NUMBER)
+ p->url_bio_method = BIO_meth_new(BIO_TYPE_SOURCE_SINK, "urlprotocol bio");
+ BIO_meth_set_write(p->url_bio_method, url_bio_bwrite);
+ BIO_meth_set_read(p->url_bio_method, url_bio_bread);
diff --git a/media-video/ffmpeg/files/ffmpeg-3.3-libressl.patch b/media-video/ffmpeg/files/ffmpeg-3.3-libressl.patch
new file mode 100644
index 0000000..afd130d
--- /dev/null
+++ b/media-video/ffmpeg/files/ffmpeg-3.3-libressl.patch
@@ -0,0 +1,57 @@
+diff -Naur ffmpeg-3.3.orig/libavformat/tls_openssl.c ffmpeg-3.3/libavformat/tls_openssl.c
+--- ffmpeg-3.3.orig/libavformat/tls_openssl.c 2017-04-14 09:44:45.035482446 -0700
++++ ffmpeg-3.3/libavformat/tls_openssl.c 2017-04-14 09:47:43.399194503 -0700
+@@ -43,7 +43,7 @@
+ TLSShared tls_shared;
+ SSL_CTX *ctx;
+ SSL *ssl;
+-#if OPENSSL_VERSION_NUMBER >= 0x1010000fL
++#if OPENSSL_VERSION_NUMBER >= 0x1010000fL && !defined(LIBRESSL_VERSION_NUMBER)
+ BIO_METHOD* url_bio_method;
+ #endif
+ } TLSContext;
+@@ -68,7 +68,7 @@
+
+ static int url_bio_create(BIO *b)
+ {
+-#if OPENSSL_VERSION_NUMBER >= 0x1010000fL
++#if OPENSSL_VERSION_NUMBER >= 0x1010000fL && !defined(LIBRESSL_VERSION_NUMBER)
+ BIO_set_init(b, 1);
+ BIO_set_data(b, NULL);
+ BIO_set_flags(b, 0);
+@@ -85,7 +85,7 @@
+ return 1;
+ }
+
+-#if OPENSSL_VERSION_NUMBER >= 0x1010000fL
++#if OPENSSL_VERSION_NUMBER >= 0x1010000fL && !defined(LIBRESSL_VERSION_NUMBER)
+ #define GET_BIO_DATA(x) BIO_get_data(x)
+ #else
+ #define GET_BIO_DATA(x) (x)->ptr
+@@ -129,7 +129,7 @@
+ return url_bio_bwrite(b, str, strlen(str));
+ }
+
+-#if OPENSSL_VERSION_NUMBER < 0x1010000fL
++#if OPENSSL_VERSION_NUMBER < 0x1010000fL || defined(LIBRESSL_VERSION_NUMBER)
+ static BIO_METHOD url_bio_method = {
+ .type = BIO_TYPE_SOURCE_SINK,
+ .name = "urlprotocol bio",
+@@ -208,7 +208,7 @@
+ SSL_CTX_free(c->ctx);
+ if (c->tls_shared.tcp)
+ ffurl_close(c->tls_shared.tcp);
+-#if OPENSSL_VERSION_NUMBER >= 0x1010000fL
++#if OPENSSL_VERSION_NUMBER >= 0x1010000fL && !defined(LIBRESSL_VERSION_NUMBER)
+ if (c->url_bio_method)
+ BIO_meth_free(c->url_bio_method);
+ #endif
+@@ -266,7 +266,7 @@
+ ret = AVERROR(EIO);
+ goto fail;
+ }
+-#if OPENSSL_VERSION_NUMBER >= 0x1010000fL
++#if OPENSSL_VERSION_NUMBER >= 0x1010000fL && !defined(LIBRESSL_VERSION_NUMBER)
+ p->url_bio_method = BIO_meth_new(BIO_TYPE_SOURCE_SINK, "urlprotocol bio");
+ BIO_meth_set_write(p->url_bio_method, url_bio_bwrite);
+ BIO_meth_set_read(p->url_bio_method, url_bio_bread);
diff --git a/media-video/ffmpeg/files/ffmpeg32-openjpeg22.patch b/media-video/ffmpeg/files/ffmpeg32-openjpeg22.patch
new file mode 100644
index 0000000..0ee6486
--- /dev/null
+++ b/media-video/ffmpeg/files/ffmpeg32-openjpeg22.patch
@@ -0,0 +1,106 @@
+commit 078322f33ced4b2db6ac3e5002f98233d6fbf643
+Author: Reino17 <rwijnsma@xs4all.nl>
+Date: Fri Jun 23 23:49:31 2017 +0200
+
+ Add support for LibOpenJPEG v2.2/git
+
+ Signed-off-by: Michael Bradshaw <mjbshaw@google.com>
+
+Index: ffmpeg-3.2.7/configure
+===================================================================
+--- ffmpeg-3.2.7.orig/configure
++++ ffmpeg-3.2.7/configure
+@@ -1831,6 +1831,7 @@ HEADERS_LIST="
+ machine_ioctl_meteor_h
+ malloc_h
+ opencv2_core_core_c_h
++ openjpeg_2_2_openjpeg_h
+ openjpeg_2_1_openjpeg_h
+ openjpeg_2_0_openjpeg_h
+ openjpeg_1_5_openjpeg_h
+@@ -5721,7 +5722,9 @@ enabled libopencv && { check_hea
+ require opencv opencv2/core/core_c.h cvCreateImageHeader -lopencv_core -lopencv_imgproc; } ||
+ require_pkg_config opencv opencv/cxcore.h cvCreateImageHeader; }
+ enabled libopenh264 && require_pkg_config openh264 wels/codec_api.h WelsGetCodecVersion
+-enabled libopenjpeg && { { check_lib2 openjpeg-2.1/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
++enabled libopenjpeg && { { check_lib2 openjpeg-2.2/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
++ check_lib2 openjpeg-2.2/openjpeg.h opj_version -lopenjp2 ||
++ { check_lib2 openjpeg-2.1/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
+ check_lib2 openjpeg-2.1/openjpeg.h opj_version -lopenjp2 ||
+ { check_lib2 openjpeg-2.0/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
+ { check_lib2 openjpeg-1.5/openjpeg.h opj_version -lopenjpeg -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
+Index: ffmpeg-3.2.7/libavcodec/libopenjpegdec.c
+===================================================================
+--- ffmpeg-3.2.7.orig/libavcodec/libopenjpegdec.c
++++ ffmpeg-3.2.7/libavcodec/libopenjpegdec.c
+@@ -34,7 +34,9 @@
+ #include "internal.h"
+ #include "thread.h"
+
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H
++# include <openjpeg-2.2/openjpeg.h>
++#elif HAVE_OPENJPEG_2_1_OPENJPEG_H
+ # include <openjpeg-2.1/openjpeg.h>
+ #elif HAVE_OPENJPEG_2_0_OPENJPEG_H
+ # include <openjpeg-2.0/openjpeg.h>
+@@ -44,7 +46,7 @@
+ # include <openjpeg.h>
+ #endif
+
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
+ # define OPENJPEG_MAJOR_VERSION 2
+ # define OPJ(x) OPJ_##x
+ #else
+@@ -429,7 +431,7 @@ static int libopenjpeg_decode_frame(AVCo
+ opj_stream_set_read_function(stream, stream_read);
+ opj_stream_set_skip_function(stream, stream_skip);
+ opj_stream_set_seek_function(stream, stream_seek);
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
+ opj_stream_set_user_data(stream, &reader, NULL);
+ #elif HAVE_OPENJPEG_2_0_OPENJPEG_H
+ opj_stream_set_user_data(stream, &reader);
+Index: ffmpeg-3.2.7/libavcodec/libopenjpegenc.c
+===================================================================
+--- ffmpeg-3.2.7.orig/libavcodec/libopenjpegenc.c
++++ ffmpeg-3.2.7/libavcodec/libopenjpegenc.c
+@@ -32,7 +32,9 @@
+ #include "avcodec.h"
+ #include "internal.h"
+
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H
++# include <openjpeg-2.2/openjpeg.h>
++#elif HAVE_OPENJPEG_2_1_OPENJPEG_H
+ # include <openjpeg-2.1/openjpeg.h>
+ #elif HAVE_OPENJPEG_2_0_OPENJPEG_H
+ # include <openjpeg-2.0/openjpeg.h>
+@@ -42,7 +44,7 @@
+ # include <openjpeg.h>
+ #endif
+
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
+ # define OPENJPEG_MAJOR_VERSION 2
+ # define OPJ(x) OPJ_##x
+ #else
+@@ -306,7 +308,7 @@ static av_cold int libopenjpeg_encode_in
+
+ opj_set_default_encoder_parameters(&ctx->enc_params);
+
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
+ switch (ctx->cinema_mode) {
+ case OPJ_CINEMA2K_24:
+ ctx->enc_params.rsiz = OPJ_PROFILE_CINEMA_2K;
+@@ -771,7 +773,7 @@ static int libopenjpeg_encode_frame(AVCo
+ opj_stream_set_write_function(stream, stream_write);
+ opj_stream_set_skip_function(stream, stream_skip);
+ opj_stream_set_seek_function(stream, stream_seek);
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
+ opj_stream_set_user_data(stream, &writer, NULL);
+ #elif HAVE_OPENJPEG_2_0_OPENJPEG_H
+ opj_stream_set_user_data(stream, &writer);
diff --git a/media-video/ffmpeg/files/openjpeg22.patch b/media-video/ffmpeg/files/openjpeg22.patch
new file mode 100644
index 0000000..a458c15
--- /dev/null
+++ b/media-video/ffmpeg/files/openjpeg22.patch
@@ -0,0 +1,106 @@
+commit 078322f33ced4b2db6ac3e5002f98233d6fbf643
+Author: Reino17 <rwijnsma@xs4all.nl>
+Date: Fri Jun 23 23:49:31 2017 +0200
+
+ Add support for LibOpenJPEG v2.2/git
+
+ Signed-off-by: Michael Bradshaw <mjbshaw@google.com>
+
+Index: ffmpeg-3.3.3/configure
+===================================================================
+--- ffmpeg-3.3.3.orig/configure
++++ ffmpeg-3.3.3/configure
+@@ -1875,6 +1875,7 @@ HEADERS_LIST="
+ machine_ioctl_meteor_h
+ malloc_h
+ opencv2_core_core_c_h
++ openjpeg_2_2_openjpeg_h
+ openjpeg_2_1_openjpeg_h
+ openjpeg_2_0_openjpeg_h
+ openjpeg_1_5_openjpeg_h
+@@ -5805,7 +5806,9 @@ enabled libopencv && { check_hea
+ require opencv opencv2/core/core_c.h cvCreateImageHeader -lopencv_core -lopencv_imgproc; } ||
+ require_pkg_config opencv opencv/cxcore.h cvCreateImageHeader; }
+ enabled libopenh264 && require_pkg_config openh264 wels/codec_api.h WelsGetCodecVersion
+-enabled libopenjpeg && { { check_lib openjpeg-2.1/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
++enabled libopenjpeg && { { check_lib openjpeg-2.2/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
++ check_lib openjpeg-2.2/openjpeg.h opj_version -lopenjp2 ||
++ { check_lib openjpeg-2.1/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
+ check_lib openjpeg-2.1/openjpeg.h opj_version -lopenjp2 ||
+ { check_lib openjpeg-2.0/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
+ { check_lib openjpeg-1.5/openjpeg.h opj_version -lopenjpeg -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
+Index: ffmpeg-3.3.3/libavcodec/libopenjpegdec.c
+===================================================================
+--- ffmpeg-3.3.3.orig/libavcodec/libopenjpegdec.c
++++ ffmpeg-3.3.3/libavcodec/libopenjpegdec.c
+@@ -34,7 +34,9 @@
+ #include "internal.h"
+ #include "thread.h"
+
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H
++# include <openjpeg-2.2/openjpeg.h>
++#elif HAVE_OPENJPEG_2_1_OPENJPEG_H
+ # include <openjpeg-2.1/openjpeg.h>
+ #elif HAVE_OPENJPEG_2_0_OPENJPEG_H
+ # include <openjpeg-2.0/openjpeg.h>
+@@ -44,7 +46,7 @@
+ # include <openjpeg.h>
+ #endif
+
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
+ # define OPENJPEG_MAJOR_VERSION 2
+ # define OPJ(x) OPJ_##x
+ #else
+@@ -429,7 +431,7 @@ static int libopenjpeg_decode_frame(AVCo
+ opj_stream_set_read_function(stream, stream_read);
+ opj_stream_set_skip_function(stream, stream_skip);
+ opj_stream_set_seek_function(stream, stream_seek);
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
+ opj_stream_set_user_data(stream, &reader, NULL);
+ #elif HAVE_OPENJPEG_2_0_OPENJPEG_H
+ opj_stream_set_user_data(stream, &reader);
+Index: ffmpeg-3.3.3/libavcodec/libopenjpegenc.c
+===================================================================
+--- ffmpeg-3.3.3.orig/libavcodec/libopenjpegenc.c
++++ ffmpeg-3.3.3/libavcodec/libopenjpegenc.c
+@@ -32,7 +32,9 @@
+ #include "avcodec.h"
+ #include "internal.h"
+
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H
++# include <openjpeg-2.2/openjpeg.h>
++#elif HAVE_OPENJPEG_2_1_OPENJPEG_H
+ # include <openjpeg-2.1/openjpeg.h>
+ #elif HAVE_OPENJPEG_2_0_OPENJPEG_H
+ # include <openjpeg-2.0/openjpeg.h>
+@@ -42,7 +44,7 @@
+ # include <openjpeg.h>
+ #endif
+
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
+ # define OPENJPEG_MAJOR_VERSION 2
+ # define OPJ(x) OPJ_##x
+ #else
+@@ -305,7 +307,7 @@ static av_cold int libopenjpeg_encode_in
+
+ opj_set_default_encoder_parameters(&ctx->enc_params);
+
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
+ switch (ctx->cinema_mode) {
+ case OPJ_CINEMA2K_24:
+ ctx->enc_params.rsiz = OPJ_PROFILE_CINEMA_2K;
+@@ -769,7 +771,7 @@ static int libopenjpeg_encode_frame(AVCo
+ opj_stream_set_write_function(stream, stream_write);
+ opj_stream_set_skip_function(stream, stream_skip);
+ opj_stream_set_seek_function(stream, stream_seek);
+-#if HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
+ opj_stream_set_user_data(stream, &writer, NULL);
+ #elif HAVE_OPENJPEG_2_0_OPENJPEG_H
+ opj_stream_set_user_data(stream, &writer);
diff --git a/media-video/ffmpeg/files/openjpeg23.patch b/media-video/ffmpeg/files/openjpeg23.patch
new file mode 100644
index 0000000..4398769
--- /dev/null
+++ b/media-video/ffmpeg/files/openjpeg23.patch
@@ -0,0 +1,109 @@
+From: Michael Bradshaw <mjbshaw at google.com>
+
+Signed-off-by: Michael Bradshaw <mjbshaw at google.com>
+---
+ configure | 5 ++++-
+ libavcodec/libopenjpegdec.c | 8 +++++---
+ libavcodec/libopenjpegenc.c | 10 ++++++----
+ 3 files changed, 15 insertions(+), 8 deletions(-)
+
+diff --git a/configure b/configure
+index 391c141e7a..77c9a18c3c 100755
+--- a/configure
++++ b/configure
+@@ -1930,6 +1930,7 @@ HEADERS_LIST="
+ machine_ioctl_meteor_h
+ malloc_h
+ opencv2_core_core_c_h
++ openjpeg_2_3_openjpeg_h
+ openjpeg_2_2_openjpeg_h
+ openjpeg_2_1_openjpeg_h
+ openjpeg_2_0_openjpeg_h
+@@ -5950,7 +5951,9 @@ enabled libopencv && { check_header opencv2/core/core_c.h &&
+ require opencv opencv2/core/core_c.h cvCreateImageHeader -lopencv_core -lopencv_imgproc; } ||
+ require_pkg_config opencv opencv/cxcore.h cvCreateImageHeader; }
+ enabled libopenh264 && require_pkg_config openh264 wels/codec_api.h WelsGetCodecVersion
+-enabled libopenjpeg && { { check_lib openjpeg-2.2/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
++enabled libopenjpeg && { { check_lib openjpeg-2.3/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
++ check_lib openjpeg-2.3/openjpeg.h opj_version -lopenjp2 ||
++ { check_lib openjpeg-2.2/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
+ check_lib openjpeg-2.2/openjpeg.h opj_version -lopenjp2 ||
+ { check_lib openjpeg-2.1/openjpeg.h opj_version -lopenjp2 -DOPJ_STATIC && add_cppflags -DOPJ_STATIC; } ||
+ check_lib openjpeg-2.1/openjpeg.h opj_version -lopenjp2 ||
+diff --git a/libavcodec/libopenjpegdec.c b/libavcodec/libopenjpegdec.c
+index 1210123265..67d47bd6a0 100644
+--- a/libavcodec/libopenjpegdec.c
++++ b/libavcodec/libopenjpegdec.c
+@@ -34,7 +34,9 @@
+ #include "internal.h"
+ #include "thread.h"
+
+-#if HAVE_OPENJPEG_2_2_OPENJPEG_H
++#if HAVE_OPENJPEG_2_3_OPENJPEG_H
++# include <openjpeg-2.3/openjpeg.h>
++#elif HAVE_OPENJPEG_2_2_OPENJPEG_H
+ # include <openjpeg-2.2/openjpeg.h>
+ #elif HAVE_OPENJPEG_2_1_OPENJPEG_H
+ # include <openjpeg-2.1/openjpeg.h>
+@@ -46,7 +48,7 @@
+ # include <openjpeg.h>
+ #endif
+
+-#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
++#if HAVE_OPENJPEG_2_3_OPENJPEG_H || HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
+ # define OPENJPEG_MAJOR_VERSION 2
+ # define OPJ(x) OPJ_##x
+ #else
+@@ -431,7 +433,7 @@ static int libopenjpeg_decode_frame(AVCodecContext *avctx,
+ opj_stream_set_read_function(stream, stream_read);
+ opj_stream_set_skip_function(stream, stream_skip);
+ opj_stream_set_seek_function(stream, stream_seek);
+-#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_3_OPENJPEG_H || HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
+ opj_stream_set_user_data(stream, &reader, NULL);
+ #elif HAVE_OPENJPEG_2_0_OPENJPEG_H
+ opj_stream_set_user_data(stream, &reader);
+diff --git a/libavcodec/libopenjpegenc.c b/libavcodec/libopenjpegenc.c
+index b67e533d1d..92b4433b04 100644
+--- a/libavcodec/libopenjpegenc.c
++++ b/libavcodec/libopenjpegenc.c
+@@ -32,7 +32,9 @@
+ #include "avcodec.h"
+ #include "internal.h"
+
+-#if HAVE_OPENJPEG_2_2_OPENJPEG_H
++#if HAVE_OPENJPEG_2_3_OPENJPEG_H
++# include <openjpeg-2.3/openjpeg.h>
++#elif HAVE_OPENJPEG_2_2_OPENJPEG_H
+ # include <openjpeg-2.2/openjpeg.h>
+ #elif HAVE_OPENJPEG_2_1_OPENJPEG_H
+ # include <openjpeg-2.1/openjpeg.h>
+@@ -44,7 +46,7 @@
+ # include <openjpeg.h>
+ #endif
+
+-#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
++#if HAVE_OPENJPEG_2_3_OPENJPEG_H || HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H || HAVE_OPENJPEG_2_0_OPENJPEG_H
+ # define OPENJPEG_MAJOR_VERSION 2
+ # define OPJ(x) OPJ_##x
+ #else
+@@ -307,7 +309,7 @@ static av_cold int libopenjpeg_encode_init(AVCodecContext *avctx)
+
+ opj_set_default_encoder_parameters(&ctx->enc_params);
+
+-#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_3_OPENJPEG_H || HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
+ switch (ctx->cinema_mode) {
+ case OPJ_CINEMA2K_24:
+ ctx->enc_params.rsiz = OPJ_PROFILE_CINEMA_2K;
+@@ -771,7 +773,7 @@ static int libopenjpeg_encode_frame(AVCodecContext *avctx, AVPacket *pkt,
+ opj_stream_set_write_function(stream, stream_write);
+ opj_stream_set_skip_function(stream, stream_skip);
+ opj_stream_set_seek_function(stream, stream_seek);
+-#if HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
++#if HAVE_OPENJPEG_2_3_OPENJPEG_H || HAVE_OPENJPEG_2_2_OPENJPEG_H || HAVE_OPENJPEG_2_1_OPENJPEG_H
+ opj_stream_set_user_data(stream, &writer, NULL);
+ #elif HAVE_OPENJPEG_2_0_OPENJPEG_H
+ opj_stream_set_user_data(stream, &writer);
+--
+2.13.5 (Apple Git-94)
diff --git a/media-video/ffmpeg/metadata.xml b/media-video/ffmpeg/metadata.xml
new file mode 100644
index 0000000..a0b4d7e
--- /dev/null
+++ b/media-video/ffmpeg/metadata.xml
@@ -0,0 +1,65 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+ <maintainer type="project">
+ <email>media-video@gentoo.org</email>
+ </maintainer>
+ <use>
+ <flag name="amr">Enables Adaptive Multi-Rate Audio support</flag>
+ <flag name="amrenc">Enables Adaptive Multi-Rate Audio encoding support with <pkg>media-libs/vo-amrwbenc</pkg>.</flag>
+ <flag name="armv5te">Enables optimizations for armv5te processors.</flag>
+ <flag name="armv6">Enables optimizations for armv6 processors.</flag>
+ <flag name="armv6t2">Enables optimizations for armv6t2 processors.</flag>
+ <flag name="armvfp">Enables VFP optimizations for ARM processors.</flag>
+ <flag name="bluray">Enable playback of Blu-ray filesystems</flag>
+ <flag name="bs2b">Enables <pkg>media-libs/libbs2b</pkg> based Bauer stereo-to-binaural filter.</flag>
+ <flag name="cdio">Enables audio CD grabbing with <pkg>dev-libs/libcdio</pkg>.</flag>
+ <flag name="celt">Adds Xiph CELT audio decoding support via <pkg>media-libs/celt</pkg></flag>
+ <flag name="chromaprint">Enables audio fingerprinting support with <pkg>media-libs/chromaprint</pkg>.</flag>
+ <flag name="chromium">Builds libffmpeg.so to enable media playback in Chromium-based browsers like Opera and Vivaldi.</flag>
+ <flag name="cpudetection">Enables runtime CPU detection (useful for bindist, compatibility on other CPUs)</flag>
+ <flag name="ebur128">Enables EBU R128 loudness normalization filter via <pkg>media-libs/libebur128</pkg></flag>
+ <flag name="fdk">Use external fdk-aac library for AAC encoding</flag>
+ <flag name="flite">Adds a text-to-speech filter based on <pkg>app-accessibility/flite</pkg>.</flag>
+ <flag name="frei0r">Enable frei0r wrapping in libavfilter</flag>
+ <flag name="fribidi">Enables fribidi support in the drawtext filter.</flag>
+ <flag name="gcrypt">Enables gcrypt support: Needed for rtmp(t)e support if openssl, librtmp or gmp is not used.</flag>
+ <flag name="gme">Enables support for <pkg>media-libs/game-music-emu</pkg> for playing various video game music formats.</flag>
+ <flag name="gpl">Build GPL code. Should be enabled unless you require LGPL binaries.</flag>
+ <flag name="hardcoded-tables">Use pre-calculated tables rather than calculating them on the fly.</flag>
+ <flag name="iec61883"> Support for FireWire DV/HDV input device using <pkg>media-libs/libiec61883</pkg>.</flag>
+ <flag name="kvazaar">Enables <pkg>media-libs/kvazaar</pkg> based HEVC encoder.</flag>
+ <flag name="libilbc">Enables iLBC de/encoding via <pkg>media-libs/libilbc</pkg>.</flag>
+ <flag name="librtmp">Enables Real Time Messaging Protocol using librtmp (<pkg>media-video/rtmpdump</pkg>) in addition to FFmpeg's native implementation.</flag>
+ <flag name="libsoxr">Enables audio resampling through <pkg>media-libs/soxr</pkg>.</flag>
+ <flag name="libv4l">Uses <pkg>media-libs/libv4l</pkg> for video4linux instead of direct calls. Adds support for more devices via the userspace library.</flag>
+ <flag name="mipsdspr1">Enables MIPS DSP ASE R1 optimizations.</flag>
+ <flag name="mipsdspr2">Enables MIPS DSP ASE R2 optimizations.</flag>
+ <flag name="mipsfpu">Enables floating point MIPS optimizations.</flag>
+ <flag name="mmal">Enables Multi-Media Abstraction Layer (MMAL) decoding support: Available e.g. on the Raspberry Pi.</flag>
+ <flag name="network">Enables network streaming support</flag>
+ <flag name="nvenc">Adds support for NVIDIA Encoder (NVENC) API for hardware accelerated encoding on NVIDIA cards.</flag>
+ <flag name="openh264">Enables H.264 encoding suppoprt via <pkg>media-libs/openh264</pkg>.</flag>
+ <flag name="openssl">Enables <pkg>dev-libs/openssl</pkg> support. Adds support for encrypted network protocols (TLS/HTTPS).</flag>
+ <flag name="opus">Adds (decoding) support for the Opus codec via <pkg>media-libs/opus</pkg>.</flag>
+ <flag name="pic">Force shared libraries to be built as PIC (this is slower)</flag>
+ <flag name="postproc">Build and install libpostproc.</flag>
+ <flag name="rubberband">Adds time-stretching and pitch-shifting audio filter based on <pkg>media-libs/rubberband</pkg>.</flag>
+ <flag name="schroedinger">Enable Dirac video support (an advanced royalty-free video compression format) via libschroedinger (high-speed implementation in C of the Dirac codec).</flag>
+ <flag name="snappy">Enable <pkg>app-arch/snappy</pkg> support. Required for e.g. Vidvox Hap encoder.</flag>
+ <flag name="sofalizer">Enables Sofalizer filter</flag>
+ <flag name="ssh">Enable SSH/sftp support via <pkg>net-libs/libssh</pkg>.</flag>
+ <flag name="twolame">Enables MP2 encoding via <pkg>media-sound/twolame</pkg> as an alternative to the internal encoder.</flag>
+ <flag name="vpx">Enables vp8 codec support using libvpx: Decoding vp8 does not require this to be enabled but libvpx can also be used for decoding; encoding vp8 requires this useflag to be enabled though.</flag>
+ <flag name="webp">Enables WebP encoding with <pkg>media-libs/libwebp</pkg>.</flag>
+ <flag name="x265">Enables HEVC encoding with <pkg>media-libs/x265</pkg>.</flag>
+ <flag name="zeromq">Enables <pkg>net-libs/zeromq</pkg> support with the zmq/azmq filters.</flag>
+ <flag name="zimg">Enables <pkg>media-libs/zimg</pkg> based scale filter.</flag>
+ <flag name="zvbi">Enables <pkg>media-libs/zvbi</pkg> based teletext decoder.</flag>
+ </use>
+ <slots>
+ <slot name="0">For building against. This is the only slot that provides
+ headers and command line tools. Binary compatibility slots come and go
+ as required, so always pin dependencies to this slot when appropriate.</slot>
+ </slots>
+</pkgmetadata>